=== debian/changelog ===
qbittorrent (5.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Tue, 11 Nov 2025 08:24:59 +0100
