=== debian/watch ===
Version: 5

Source: https://sf.net/qbittorrent/
Matching-Pattern: qbittorrent-([\d\.]*(?:rc\d)?)@ARCHIVE_EXT@
Pgpmode: auto
Uversionmangle: s/rc/~rc/
