## qbittorrent 5.1.4

=== debian/changelog ===
qbittorrent (5.1.4-1~mx25+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 24 Nov 2025 08:57:28 -0800
