=== debian/control ===
Source: qbittorrent
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Christian Marillat <marillat@debian.org>
Homepage: https://www.qbittorrent.org/
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-dev (>= 1.76~),
               libtorrent-rasterbar-dev (>= 2.0.9~),
               libxkbcommon-dev,
               ninja-build,
               pkgconf,
               qt6-base-dev,
               qt6-base-private-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               systemd-dev,
               zlib1g-dev

Package: qbittorrent
Architecture: any
Depends: libqt6sql6-sqlite, qt6-svg-plugins, ${misc:Depends}, ${shlibs:Depends}
Description: bittorrent client based on libtorrent-rasterbar with a Qt6 GUI
 BitTorrent client written in C++ and based on libtorrent-rasterbar with a
 Qt6 user interface. qBittorrent is a feature rich but lightweight client
 that is very similar to uTorrent. Its main features are:
 .
  * Polished uTorrent-like user interface
  * Well integrated and extensible search engine
  * Remote control through a Web user interface
  * Vuze-compatible protocol encryption
  * uTorrent-compatible Peer eXchange (PeX)
  * DHT (trackerless) support
  * UPnP / NAT-PMP port forwarding
  * IPv6 compliant
  * RSS support with advanced download filters
  * Advanced control over torrent content and trackers
  * IP Filtering (eMule / Peer Guardian filters)
  * Torrents queueing and prioritizing
  * Good localization (~25 languages supported)
  * Unicode support

Package: qbittorrent-nox
Architecture: any
Depends: libqt6sql6-sqlite, ${misc:Depends}, ${shlibs:Depends}
Description: bittorrent client based on libtorrent-rasterbar (without X support)
 BitTorrent client written in C++ and based on libtorrent-rasterbar.
 qBittorrent-nox is a version of qBittorrent (Qt6 application) that does not
 require X and can be controlled via a WebUI, thus is more suitable for
 headless servers. It is a feature rich but lightweight client that is very
 similar to rTorrent. Its main features are:
 .
  * Remote control through a Web user interface
  * Vuze-compatible protocol encryption
  * uTorrent-compatible Peer eXchange (PeX)
  * DHT (trackerless) support
  * UPnP / NAT-PMP port forwarding
  * IPv6 compliant
  * Advanced control over torrent content and trackers
  * IP Filtering (eMule / Peer Guardian filters)
  * Torrents queueing and prioritizing
  * Good localization (~25 languages supported)
  * Unicode support
